Subject: Re: [PATCH 5/5] make netlink user -> kernel interface synchronious

From: Patrick McHardy <[email-masked]>
Date: Fri, 05 Oct 2007 18:24:27 +0200

Denis V. Lunev wrote:
> This patch make processing netlink user -> kernel messages synchronious.
> This change was inspired by the talk with Alexey Kuznetsov about current
> netlink messages processing. He says that he was badly wrong when introduced 
> asynchronious user -> kernel communication.
> 
> The call netlink_unicast is the only path to send message to the kernel
> netlink socket. But, unfortunately, it is also used to send data to the
> user.
> 
> Before this change the user message has been attached to the socket queue
> and sk->sk_data_ready was called. The process has been blocked until all
> pending messages were processed. The bad thing is that this processing
> may occur in the arbitrary process context.
> 
> This patch changes nlk->data_ready callback to get 1 skb and force packet
> processing right in the netlink_unicast.

I guess the process credential stuff in netlink_skb_params can now
be removed as well.